diff --git a/src/backend/rewrite/rewriteGraphTable.c b/src/backend/rewrite/rewriteGraphTable.c
index 9c14fa3b1b7..80e28db752d 100644
--- a/src/backend/rewrite/rewriteGraphTable.c
+++ b/src/backend/rewrite/rewriteGraphTable.c
@@ -14,6 +14,7 @@
 #include "postgres.h"
 
 #include "access/table.h"
+#include "catalog/pg_operator.h"
 #include "catalog/pg_propgraph_element.h"
 #include "catalog/pg_propgraph_element_label.h"
 #include "catalog/pg_propgraph_label.h"
@@ -23,7 +24,10 @@
 #include "nodes/nodeFuncs.h"
 #include "optimizer/optimizer.h"
 #include "parser/analyze.h"
+#include "parser/parse_collate.h"
+#include "parser/parse_func.h"
 #include "parser/parse_node.h"
+#include "parser/parse_oper.h"
 #include "parser/parse_relation.h"
 #include "parser/parsetree.h"
 #include "parser/parse_relation.h"
@@ -83,7 +87,7 @@ struct path_element
 };
 
 static Node *replace_property_refs(Oid propgraphid, Node *node, const List *mappings);
-static List *build_edge_vertex_link_quals(HeapTuple edgetup, int edgerti, int refrti, AttrNumber catalog_key_attnum, AttrNumber catalog_ref_attnum);
+static List *build_edge_vertex_link_quals(HeapTuple edgetup, int edgerti, int refrti, Oid refid, AttrNumber catalog_key_attnum, AttrNumber catalog_ref_attnum, AttrNumber catalog_eqop_attnum);
 static List *generate_queries_for_path_pattern(RangeTblEntry *rte, List *element_patterns);
 static Query *generate_query_for_graph_path(RangeTblEntry *rte, List *path);
 static Node *generate_setop_from_pathqueries(List *pathqueries, List **rtable, List **targetlist);
@@ -373,6 +377,23 @@ generate_queries_for_path_pattern_recurse(RangeTblEntry *rte, List *pathqueries,
 /*
  * Construct a query representing given graph path.
  *
+ * The query contains:
+ *
+ * 1. targetlist corresponding the COLUMNS clause of GRAPH_TABLE clause
+ *
+ * 2. quals corresponding to the WHERE clause of individual elements, WHERE
+ * clause in GRAPH_TABLE clause and quals representing edge-vertex links.
+ *
+ * 3. fromlist containing all elements in the path
+ *
+ * The collations of property expressions are obtained from the catalog and
+ * substituted in place of a property reference. The collations of expressions
+ * in COLUMNS and WHERE clauses are assigned before rewriting the graph table.
+ * The collations of the edge-vertex link quals are assigned when crafting those
+ * quals. Thus everything in the query that requires collation assignment has
+ * been taken care of already. So no collation assignment is required in this
+ * function.
+ *
  * More details in the prologue of generate_queries_for_path_pattern().
  */
 static Query *
@@ -552,6 +573,12 @@ generate_query_for_empty_path_pattern(RangeTblEntry *rte)
 /*
  * Construct a query which is UNION of given path queries.
  *
+ * The UNION query derives collations of its targetlist entries from the
+ * corresponding targetlist entries of the path queries and projects it. The
+ * targetlists of path queries being UNION'ed already have collations assigned.
+ * The same collations are used for targetlist of UNION query. Thus there is no
+ * separate collation assignment required in this function.
+ *
  * The function destroys given pathqueries list while constructing
  * SetOperationStmt recrursively. Hence the function always returns with
  * `pathqueries` set to NIL.
@@ -747,11 +774,15 @@ create_gpe_for_element(struct path_factor *pf, Oid elemoid)
 		 * each time.
 		 */
 		pe->src_quals = build_edge_vertex_link_quals(eletup, pf->factorpos + 1, pf->src_pf->factorpos + 1,
+													 pe->srcvertexid,
 													 Anum_pg_propgraph_element_pgesrckey,
-													 Anum_pg_propgraph_element_pgesrcref);
+													 Anum_pg_propgraph_element_pgesrcref,
+													 Anum_pg_propgraph_element_pgesrceqop);
 		pe->dest_quals = build_edge_vertex_link_quals(eletup, pf->factorpos + 1, pf->dest_pf->factorpos + 1,
+													  pe->destvertexid,
 													  Anum_pg_propgraph_element_pgedestkey,
-													  Anum_pg_propgraph_element_pgedestref);
+													  Anum_pg_propgraph_element_pgedestref,
+													  Anum_pg_propgraph_element_pgedesteqop);
 	}
 
 	ReleaseSysCache(eletup);
@@ -1122,18 +1153,26 @@ replace_property_refs(Oid propgraphid, Node *node, const List *mappings)
 }
 
 /*
- * Build join qualification expressions between edge and vertex tables.
+ * Build join qualification expressions between edge and vertex tables using
+ * equality operators identified at the time of creating the edge.
  */
 static List *
-build_edge_vertex_link_quals(HeapTuple edgetup, int edgerti, int refrti, AttrNumber catalog_key_attnum, AttrNumber catalog_ref_attnum)
+build_edge_vertex_link_quals(HeapTuple edgetup, int edgerti, int refrti, Oid refid, AttrNumber catalog_key_attnum, AttrNumber catalog_ref_attnum, AttrNumber catalog_eqop_attnum)
 {
 	List	   *quals = NIL;
 	Form_pg_propgraph_element pgeform;
 	Datum		datum;
 	Datum	   *d1,
-			   *d2;
+			   *d2,
+			   *d3;
 	int			n1,
-				n2;
+				n2,
+				n3;
+	ParseState *pstate = make_parsestate(NULL);
+	HeapTuple	reftup = SearchSysCache1(PROPGRAPHELOID, ObjectIdGetDatum(refid));
+	Oid			refrelid = ((Form_pg_propgraph_element) GETSTRUCT(reftup))->pgerelid;
+
+	ReleaseSysCache(reftup);
 
 	pgeform = (Form_pg_propgraph_element) GETSTRUCT(edgetup);
 
@@ -1143,33 +1182,74 @@ build_edge_vertex_link_quals(HeapTuple edgetup, int edgerti, int refrti, AttrNum
 	datum = SysCacheGetAttrNotNull(PROPGRAPHELOID, edgetup, catalog_ref_attnum);
 	deconstruct_array_builtin(DatumGetArrayTypeP(datum), INT2OID, &d2, NULL, &n2);
 
+	datum = SysCacheGetAttrNotNull(PROPGRAPHELOID, edgetup, catalog_eqop_attnum);
+	deconstruct_array_builtin(DatumGetArrayTypeP(datum), OIDOID, &d3, NULL, &n3);
+
 	if (n1 != n2)
 		elog(ERROR, "array size key (%d) vs ref (%d) mismatch for element ID %u", catalog_key_attnum, catalog_ref_attnum, pgeform->oid);
+	if (n1 != n3)
+		elog(ERROR, "array size key (%d) vs operator (%d) mismatch for element ID %u", catalog_key_attnum, catalog_eqop_attnum, pgeform->oid);
 
 	for (int i = 0; i < n1; i++)
 	{
 		AttrNumber	keyattn = DatumGetInt16(d1[i]);
 		AttrNumber	refattn = DatumGetInt16(d2[i]);
+		Oid			eqop = DatumGetObjectId(d3[i]);
+		Var		   *keyvar;
+		Var		   *refvar;
 		Oid			atttypid;
-		TypeCacheEntry *typentry;
-		OpExpr	   *op;
+		int32		atttypmod;
+		Oid			attcoll;
+		HeapTuple	tup;
+		Form_pg_operator opform;
+		List	   *args;
+		Oid			actual_arg_types[2];
+		Oid			declared_arg_types[2];
+		OpExpr	   *linkqual;
+
+		get_atttypetypmodcoll(pgeform->pgerelid, keyattn, &atttypid, &atttypmod, &attcoll);
+		keyvar = makeVar(edgerti, keyattn, atttypid, atttypmod, attcoll, 0);
+		get_atttypetypmodcoll(refrelid, refattn, &atttypid, &atttypmod, &attcoll);
+		refvar = makeVar(refrti, refattn, atttypid, atttypmod, attcoll, 0);
+
+		tup = SearchSysCache1(OPEROID, ObjectIdGetDatum(eqop));
+		if (!HeapTupleIsValid(tup))
+			elog(ERROR, "cache lookup failed for operator %u", eqop);
+		opform = (Form_pg_operator) GETSTRUCT(tup);
+		/* An equality operator is a binary operator returning boolean result. */
+		Assert(opform->oprkind == 'b'
+			   && RegProcedureIsValid(opform->oprcode)
+			   && opform->oprresult == BOOLOID
+			   && !get_func_retset(opform->oprcode));
 
 		/*
-		 * TODO: Assumes types the same on both sides; no collations yet. Some
-		 * of this could probably be shared with foreign key triggers.
+		 * Prepare operands and cast them to the types required by the
+		 * equality operator. Similar to PK/FK qauls, referenced vertex key is
+		 * used as left operand and referencing edge key is used as right
+		 * operand.
 		 */
-		atttypid = get_atttype(pgeform->pgerelid, keyattn);
-		typentry = lookup_type_cache(atttypid, TYPECACHE_EQ_OPR);
-
-		op = makeNode(OpExpr);
-		op->location = -1;
-		op->opno = typentry->eq_opr;
-		op->opresulttype = BOOLOID;
-		op->args = list_make2(makeVar(edgerti, keyattn, atttypid, -1, 0, 0),
-							  makeVar(refrti, refattn, atttypid, -1, 0, 0));
-		quals = lappend(quals, op);
+		args = list_make2(refvar, keyvar);
+		actual_arg_types[0] = exprType((Node *) refvar);
+		actual_arg_types[1] = exprType((Node *) keyvar);
+		declared_arg_types[0] = opform->oprleft;
+		declared_arg_types[1] = opform->oprright;
+		make_fn_arguments(pstate, args, actual_arg_types, declared_arg_types);
+
+		linkqual = makeNode(OpExpr);
+		linkqual->opno = opform->oid;
+		linkqual->opfuncid = opform->oprcode;
+		linkqual->opresulttype = opform->oprresult;
+		linkqual->opretset = false;
+		/* opcollid and inputcollid will be set by parse_collate.c */
+		linkqual->args = args;
+		linkqual->location = -1;
+
+		ReleaseSysCache(tup);
+		quals = lappend(quals, linkqual);
 	}
 
+	assign_expr_collations(pstate, (Node *) quals);
+
 	return quals;
 }
 
diff --git a/src/include/catalog/pg_propgraph_element.h b/src/include/catalog/pg_propgraph_element.h
index 2bc2066b6c1..fea06c0963e 100644
--- a/src/include/catalog/pg_propgraph_element.h
+++ b/src/include/catalog/pg_propgraph_element.h
@@ -62,6 +62,11 @@ CATALOG(pg_propgraph_element,8299,PropgraphElementRelationId)
 	 */
 	int16		pgesrcref[1];
 
+	/*
+	 * for edges: Oids of the equality operators for comparing source keys
+	 */
+	Oid			pgesrceqop[1];
+
 	/*
 	 * for edges: destination vertex key (column numbers in pgerelid relation)
 	 */
@@ -72,6 +77,12 @@ CATALOG(pg_propgraph_element,8299,PropgraphElementRelationId)
 	 * in relation reached via pgedestvertexid)
 	 */
 	int16		pgedestref[1];
+
+	/*
+	 * for edges: Oids of the equality operators for comparing destination
+	 * keys
+	 */
+	Oid			pgedesteqop[1];
 #endif
 } FormData_pg_propgraph_element;
 
diff --git a/src/include/catalog/pg_propgraph_property.h b/src/include/catalog/pg_propgraph_property.h
index b8921ace30c..240b34f0390 100644
--- a/src/include/catalog/pg_propgraph_property.h
+++ b/src/include/catalog/pg_propgraph_property.h
@@ -36,6 +36,12 @@ CATALOG(pg_propgraph_property,8306,PropgraphPropertyRelationId)
 
 	/* data type of the property */
 	Oid			pgptypid BKI_LOOKUP_OPT(pg_type);
+
+	/* typemod of the property */
+	int32		pgptypmod;
+
+	/* collation of the property */
+	Oid			pgpcollation BKI_LOOKUP_OPT(pg_collation);
 } FormData_pg_propgraph_property;
 
 /* ----------------
diff --git a/src/include/nodes/primnodes.h b/src/include/nodes/primnodes.h
index bb9584bc92d..42a3addd8b2 100644
--- a/src/include/nodes/primnodes.h
+++ b/src/include/nodes/primnodes.h
@@ -2176,6 +2176,8 @@ typedef struct GraphPropertyRef
 	const char *elvarname;
 	Oid			propid;
 	Oid			typeId;
+	int32		typmod;
+	Oid			collation;
 	ParseLoc	location;
 } GraphPropertyRef;
 
diff --git a/src/test/regress/sql/create_property_graph.sql b/src/test/regress/sql/create_property_graph.sql
index 4f9b5c0349b..9a1fe4fc6de 100644
--- a/src/test/regress/sql/create_property_graph.sql
+++ b/src/test/regress/sql/create_property_graph.sql
@@ -147,6 +147,83 @@ GRANT SELECT ON PROPERTY GRAPH g1 TO regress_graph_user2;
 GRANT UPDATE ON PROPERTY GRAPH g1 TO regress_graph_user2;  -- fail
 RESET ROLE;
 
+-- collation
+CREATE TABLE tc1 (a int, b text);
+CREATE TABLE tc2 (a int, b text);
+CREATE TABLE tc3 (a int, b text COLLATE "C");
+
+CREATE TABLE ec1 (ek1 int, ek2 int, eb text);
+CREATE TABLE ec2 (ek1 int, ek2 int, eb text COLLATE "POSIX");
+
+CREATE PROPERTY GRAPH gc1
+    VERTEX TABLES (tc1 KEY (a), tc2 KEY (a), tc3 KEY (a)); -- fail
+CREATE PROPERTY GRAPH gc1
+    VERTEX TABLES (tc1 KEY (a), tc2 KEY (a))
+    EDGE TABLES (
+        ec1 KEY (ek1, ek2)
+            SOURCE KEY (ek1) REFERENCES tc1 (a)
+            DESTINATION KEY (ek2) REFERENCES tc2 (a),
+        ec2 KEY (ek1, ek2)
+            SOURCE KEY (ek1) REFERENCES tc1 (a)
+            DESTINATION KEY (ek2) REFERENCES tc2 (a)); -- fail
+CREATE PROPERTY GRAPH gc1
+    VERTEX TABLES (tc1 KEY (a) DEFAULT LABEL PROPERTIES (a), tc3 KEY (b))
+    EDGE TABLES (
+        ec2 KEY (ek1, eb)
+            SOURCE KEY (ek1) REFERENCES tc1 (a)
+            DESTINATION KEY (eb) REFERENCES tc3 (b)); -- fail
+CREATE PROPERTY GRAPH gc1
+    VERTEX TABLES (tc1 KEY (a), tc2 KEY (a))
+    EDGE TABLES (
+        ec1 KEY (ek1, ek2)
+            SOURCE KEY (ek1) REFERENCES tc1 (a)
+            DESTINATION KEY (ek2) REFERENCES tc2 (a));
+ALTER PROPERTY GRAPH gc1 ADD VERTEX TABLES (tc3 KEY (a)); -- fail
+ALTER PROPERTY GRAPH gc1 ADD EDGE TABLES (
+            ec2 KEY (ek1, ek2)
+                SOURCE KEY (ek1) REFERENCES tc1 (a)
+                DESTINATION KEY (ek2) REFERENCES tc2 (a)); -- fail
+ALTER PROPERTY GRAPH gc1
+    ADD VERTEX TABLES (
+        tc3 KEY (a) DEFAULT LABEL PROPERTIES (a, b COLLATE pg_catalog.DEFAULT AS b));
+ALTER PROPERTY GRAPH gc1 ADD EDGE TABLES (
+            ec2 KEY (ek1, ek2)
+                SOURCE KEY (ek1) REFERENCES tc1 (a)
+                DESTINATION KEY (ek2) REFERENCES tc2 (a)
+                DEFAULT LABEL PROPERTIES (ek1, ek2, eb COLLATE pg_catalog.DEFAULT AS eb));
+DROP PROPERTY GRAPH gc1;
+CREATE PROPERTY GRAPH gc1
+    VERTEX TABLES (
+        tc1 KEY (a) DEFAULT LABEL PROPERTIES (a, b::varchar COLLATE "C" AS b),
+        tc2 KEY (a) DEFAULT LABEL PROPERTIES (a, (b COLLATE "C")::varchar AS b),
+        tc3 KEY (a) DEFAULT LABEL PROPERTIES (a, b::varchar AS b))
+    EDGE TABLES (
+        ec1 KEY (ek1, ek2)
+            SOURCE KEY (ek1) REFERENCES tc1 (a)
+            DESTINATION KEY (ek2) REFERENCES tc2 (a)
+            DEFAULT LABEL PROPERTIES (ek1, ek2, eb),
+        ec2 KEY (ek1, ek2)
+            SOURCE KEY (ek1) REFERENCES tc1 (a)
+            DESTINATION KEY (ek2) REFERENCES tc2 (a)
+            DEFAULT LABEL PROPERTIES (ek1, ek2, eb COLLATE pg_catalog.DEFAULT AS eb));
+
+-- type incosistency check
+CREATE TABLE v1 (a int primary key, b text);
+CREATE TABLE e(k1 text, k2 text, c text);
+CREATE TABLE v2 (m text, n text);
+CREATE PROPERTY GRAPH gt
+    VERTEX TABLES (v1 KEY (a), v2 KEY (m))
+    EDGE TABLES (
+        e KEY (k1, k2)
+        SOURCE KEY (k1) REFERENCES v1(a)
+        DESTINATION KEY (k2) REFERENCES v2(m)); -- fail
+ALTER TABLE e DROP COLUMN k1, ADD COLUMN k1 bigint primary key;
+CREATE PROPERTY GRAPH gt
+    VERTEX TABLES (v1 KEY (a), v2 KEY (m))
+    EDGE TABLES (
+        e KEY (k1, k2)
+        SOURCE KEY (k1) REFERENCES v1(a)
+        DESTINATION KEY (k2) REFERENCES v2(m));
 
 -- information schema
 
diff --git a/src/test/regress/sql/graph_table.sql b/src/test/regress/sql/graph_table.sql
index 905be9df01b..977bf2774e5 100644
--- a/src/test/regress/sql/graph_table.sql
+++ b/src/test/regress/sql/graph_table.sql
@@ -322,7 +322,8 @@ SELECT * FROM GRAPH_TABLE (g1 MATCH (a is vl1)->(b)->(a is vl2) WHERE a.vname <>
 SELECT * FROM GRAPH_TABLE (g1 MATCH (a is vl1)->(b)->(a) COLUMNS (a.vname AS self, b.vname AS through, a.vprop1 AS self_p1, b.vprop1 AS through_p1)) ORDER BY self, through;
 SELECT * FROM GRAPH_TABLE (g1 MATCH (a)->(b)->(a is vl1) COLUMNS (a.vname AS self, b.vname AS through, a.vprop1 AS self_p1, b.vprop1 AS through_p1)) ORDER BY self, through;
 
--- add an edge with same vertex as source and destination to test loops
+-- add an edge with same vertex as source and destination to test loops. Also
+-- use this for collation tests
 CREATE TABLE e3_3 (src_id int,
                     dest_id int,
                     ename varchar(10),
@@ -336,37 +337,53 @@ ALTER PROPERTY GRAPH g1 ADD EDGE TABLES (
 );
 
 INSERT INTO e3_3 VALUES (2003, 2003, 'e331', 10010);
+INSERT INTO e3_3 VALUES (2003, 2003, 'E331', 10010);
 -- cyclic pattern with edge patterns with same variable name
-SELECT * FROM GRAPH_TABLE (g1 MATCH (a)-[b]->(a)-[b]->(a) COLUMNS (a.vname AS self, b.ename AS loop_name));
+SELECT * FROM GRAPH_TABLE (g1 MATCH (a)-[b]->(a)-[b]->(a) COLUMNS (a.vname AS self, b.ename AS loop_name)) ORDER BY loop_name ASC;
+SELECT * FROM GRAPH_TABLE (g1 MATCH (a)-[b]->(a)-[b]->(a) COLUMNS (a.vname AS self, b.ename AS loop_name)) ORDER BY loop_name COLLATE "C" ASC;
+SELECT * FROM GRAPH_TABLE (g1 MATCH (a)-[b IS el2 WHERE b.ename > 'E331' COLLATE "C"]->(a)-[b]->(a) COLUMNS (a.vname AS self, b.ename AS loop_name));
+SELECT * FROM GRAPH_TABLE (g1 MATCH (a)-[b]->(a)-[b]->(a) WHERE b.ename > 'E331' COLLATE "C" COLUMNS (a.vname AS self, b.ename AS loop_name));
+SELECT * FROM GRAPH_TABLE (g1 MATCH (a)-[b]->(a)-[b]->(a) COLUMNS (a.vname AS self, b.ename AS loop_name)) WHERE loop_name > 'E331' COLLATE "C";
 SELECT * FROM GRAPH_TABLE (g1 MATCH (a)-[b]->(c)-[b]->(d) COLUMNS (a.vname AS aname, b.ename AS bname, c.vname AS cname, d.vname AS dname)); --error
 
 -- property graph with some of the elements, labels and properties same as the
 -- previous one. Test whether components from the specified property graph are
--- used.
+-- used. Also use this for collation tests
 create property graph g2
 vertex tables (
 	v1
-        label l1 properties ('g2.' || vname as elname),
+        label l1 properties ('g2.' || vname COLLATE "C" as elname),
 	v2 key (id1, id2)
-        label l1 properties ('g2.' || vname as elname),
+        label l1 properties ('g2.' || vname COLLATE "C" as elname),
 	v3
-        label l1 properties ('g2.' || vname as elname)
+        label l1 properties ('g2.' || vname COLLATE "C" as elname)
 )
 edge tables (
 	e1_2 key (id_1, id_2_1, id_2_2)
 		source key (id_1) references v1 (id)
 		destination key (id_2_1, id_2_2) references v2 (id1, id2)
-        label l1 properties ('g2.' || ename as elname),
+        label l1 properties ('g2.' || ename COLLATE "C" as elname),
 	e1_3
 		source key (id_1) references v1 (id)
 		destination key (id_3) references v3 (id)
-        label l1 properties ('g2.' || ename as elname),
+        label l1 properties ('g2.' || ename COLLATE "C" as elname),
     e2_3 key (id_2_1, id_2_2, id_3)
         source key (id_2_1, id_2_2) references v2 (id1, id2)
         destination key (id_3) references v3 (id)
-        label l1 properties ('g2.' || ename as elname)
+        label l1 properties ('g2.' || ename COLLATE "C" as elname),
+    e3_3 KEY (src_id, dest_id)
+        SOURCE KEY (src_id) REFERENCES v3 (id)
+        DESTINATION KEY (src_id) REFERENCES v3 (id)
+        LABEL l1 PROPERTIES ('g2.' || ename COLLATE "C" as elname)
 );
-select sn, cn, dn from graph_table (g2 match (src : l1)-[conn : l1]->(dest : l1) columns (src.elname as sn, conn.elname as cn, dest.elname as dn));
+select sn, cn, dn from graph_table (g2 match (src : l1)-[conn : l1]->(dest : l1) columns (src.elname as sn, conn.elname as cn, dest.elname as dn)) ORDER BY 1, 2, 3;
+SELECT * FROM GRAPH_TABLE (g2 MATCH (a)-[b]->(a)-[b]->(a) COLUMNS (a.elname AS self, b.elname COLLATE pg_catalog."default" AS loop_name)) ORDER BY loop_name ASC;
+SELECT * FROM GRAPH_TABLE (g2 MATCH (a)-[b WHERE b.elname > 'g2.E331']->(a)-[b]->(a) COLUMNS (a.elname AS self, b.elname AS loop_name));
+SELECT * FROM GRAPH_TABLE (g2 MATCH (a)-[b]->(a)-[b]->(a) WHERE b.elname > 'g2.E331' COLUMNS (a.elname AS self, b.elname AS loop_name));
+SELECT * FROM GRAPH_TABLE (g2 MATCH (a)-[b]->(a)-[b]->(a) COLUMNS (a.elname AS self, b.elname AS loop_name)) WHERE loop_name > 'g2.E331';
+SELECT * FROM GRAPH_TABLE (g2 MATCH (a)-[b WHERE b.elname > 'g2.e331' COLLATE pg_catalog."default"]->(a)-[b]->(a) COLUMNS (a.elname AS self, b.elname AS loop_name));
+SELECT * FROM GRAPH_TABLE (g2 MATCH (a)-[b]->(a)-[b]->(a) WHERE b.elname > 'g2.e331' COLLATE pg_catalog."default" COLUMNS (a.elname AS self, b.elname AS loop_name));
+SELECT * FROM GRAPH_TABLE (g2 MATCH (a)-[b]->(a)-[b]->(a) COLUMNS (a.elname AS self, b.elname AS loop_name)) WHERE loop_name > 'g2.e331' COLLATE pg_catalog."default";
 
 CREATE VIEW customers_us AS SELECT customer_name FROM GRAPH_TABLE (myshop MATCH (c IS customers WHERE c.address = 'US')-[IS customer_orders]->(o IS orders) COLUMNS (c.name AS customer_name));
 
@@ -428,6 +445,10 @@ SELECT *
                               COLUMNS (cg.name_redacted AS customer_name_redacted))
     WHERE co.customer_id = 1;
 
+-- graph table in a subquery
+SELECT * FROM customers co WHERE co.customer_id =
+    (SELECT customer_id FROM GRAPH_TABLE (myshop2 MATCH (cg IS customers WHERE cg.address = 'US')-[IS customer_orders]->(o IS orders) COLUMNS (cg.customer_id)));
+
 -- query within graph table
 SELECT sname, dname
     FROM GRAPH_TABLE (g1 MATCH (src)->(dest)
-- 
2.39.5

